## Framework Version 2

**This framework version is DEPRECATED for new modules, and upgrading is recommended for existing modules.**  See the [Versioning README](README.md) for the latest framework version and more details on framework versions in general.

#### Breaking Changes
* A `framework` member variable is now automatically added to the module class that will house all future methods.  If any modules previously defined their own `framework` member variable, they will need to be refactored to use a different variable name instead.
* Calling `$module->framework->getSubSettings()` will return slightly different output than calling `$module->getSubSettings()`.  The framework provided version handles complex nested settings much more accurately, but has some subtle differences preventing full backward compatibility with the method directly on the module class.  Some modules will be able to switch to the new implementation seamlessly, while others will need to implement a transition process specific to that module.  Possible strategies for transitioning modules to the new implementation include:
  * Programmatically detecting & updating affected settings in the `redcap_module_configuration_settings` hook when a user loads the configuration dialog.
  * Programmatically detecting & updating affected settings as each setting is retrieved from one of the settings methods.
  * Notifying users that they need to manually re-enter affected settings on all projects (perhaps the safest & least time consuming option in some cases).
