<?php
namespace ExternalModules;

class SniffMessagesTest extends BaseTest
{
    function testContainsDataTableName(){
        $assert = function($expected, $s, $testWithAppendedNumbers=true){
            $this->assertSame($expected, SniffMessages::containsDataTableName($s));

            if($testWithAppendedNumbers){
                $s = str_replace('redcap_data', 'redcap_data2', $s);
                $this->assertSame($expected, SniffMessages::containsDataTableName($s));
    
                $s = str_replace('redcap_data2', 'redcap_data20', $s);
                $this->assertSame($expected, SniffMessages::containsDataTableName($s));
            }
        };

        $assert(true, 'redcap_data');
        $assert(true, ' redcap_data');
        $assert(true, 'redcap_data ');
        $assert(true, '.redcap_data');
        $assert(true, 'redcap_data)');

        $assert(false, 'redcap_data_');
        $assert(false, '_redcap_data');
        $assert(false, '^redcap_data'); // Ignore data table regexes like from https://github.com/ctsit/move_data_to_other_event
        
        // Ignore object type column references like from https://github.com/vanderbilt-redcap/redcap_log_audit_tool
        $assert(false, "object_type = 'redcap_data'", false);
        $assert(false, 'object_type = "redcap_data"', false);
        $assert(false, "object_type in ('redcap_data')", false);
        $assert(false, 'object_type in ("redcap_data")', false);
    }
}